Redmine - Defect #9749

Entering data into the 'Parent Task’ field in new or updated issues causes redmine to log out the
current user.

2011-12-07 18:59 - James Kyle

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour

Target version:

Resolution: Invalid Affected version:

Description

About your application's environment

Ruby version 1.8.7 (x86_64-1inux)
RubyGems version

Rack version

Rails version

Active Record version
Active Resource version

Action Mailer version .14

Active Support version 3.14

Application root /home/redmine/releases/20111207004106
Environment production

Database adapter postgresqgl

Database schema version 20111201201315

About your Redmine plugins

Redmine Backlogs master branch (unstable)
Redmine Tags 0.0.1

Redmine Workflow Viz plugin 0.0.1

The following log output occurs when the field is populated:
Processing AutoCompletesController#issues (for x.x.x.x at 2011-12-07 17:42:31) [POST]
Parameters: {"project_id"=>"riak", "action"=>"issues", "amp"=>nil, "id"=>"6907", "g"=>"6898", "c
ontroller"=>"auto_completes"}
Filter chain halted as [:check_if_login_required] rendered_or_redirected.
Completed in 9ms (View: 1, DB: 2) | 401 Unauthorized [https://redmine.domain.com/issues/auto_compl

ete?1d=6907&amp;project_id=riak]

As you can see, redmine performs a login check and returns "unauthorized". The user account that performed this action is a site
wide administrator with full rights. The behavior did not arise until we recently updated to master (from a relatively old deployment).

| can take that request, /issues/auto_complete?id=6907&project_id=riak, log in and directly call the url and | get a 200 OK response.

The last thing of interest is the javascript console error output. I've attached a screen shot, but the only error is "ReferenceError:
Can't find variable: WarnLeavingUnsaved" that comes from this call "

Event .observe (window, 'load', function(){ new WarnLeavingUnsaved('The current page contains unsave
d text that will be lost if you leave this page.'); 1});

The rest are just 401 responses. I've also included a screen shot of the behavior when a user populates the parent task field.

Let me know if | can provide more information.

Related issues:
Related to Redmine - Defect #9752: "Subtasks autocompletion" feature breaks "... Closed

History

#1 - 2011-12-07 19:12 - Jean-Philippe Lang

Can you check that the AJAX request that gets a 401 is made on the same exact proto://domain as regular requests?
For your js error, it looks like you're not loading the fresh application.js (which defines WarnLeavingUnsaved).
#2 - 2011-12-07 19:54 - James Kyle
Jean-Philippe Lang wrote:
Can you check that the AJAX request that gets a 401 is made on the same exact proto://domain as regular requests?
My apologies if I'm misunderstanding 'pro to://domain'. But the loaded *.js files are from the same domain...all relative url paths. | also grepped
through the /public/javascripts for the function in my installation and found nothing.
For your s error, it looks like you're not loading the fresh application.js (which defines WarnLeavingUnsaved).
| just checked the application.js from HEAD and the WarnLeavingUnsaved method is not defined there (checked it in the redmine repo, not my local
one).
| dug up an old definition, going to play with that.
#3 - 2011-12-07 19:57 - James Kyle
Copying and pasting the WarnLeavingUnsaved method into my current application.js eliminated those errors.
However, the described behavior persists. So | suppose that, in this case, the missing method was a red herring. . .
The only error now left is the call to :check_if_login_required and the subsequent 401 response.
#4 - 2011-12-07 21:18 - Jean-Philippe Lang
James Kyle wrote:
| just checked the application.js from HEAD and the WarnLeavingUnsaved method is not defined there (checked it in the redmine repo, not my

local one).

See: source:/trunk/public/javascripts/application.js@7926#1.337

The only error now left is the call to :check_if_login_required and the subsequent 401 response.

No clue. It looks like your session cookie is not sent within the AJAX request.

#5 - 2011-12-08 20:12 - Jean-Philippe Lang
| think your session is killed because the CSRF token is not sent within your ajax POST request (any POST without the CSRF token terminates the
session).

This CSRF token is added automatically to each AJAX request using javascript, and because you didn't have a fresh application.js, this may be the
problem.

Please make sure you have a fresh application.js with the code that sets X-CSRF-Token header on AJAX requests.
See: source:/trunk/public/javascripts/application.js@7926#1.384

#6 - 2011-12-09 01:28 - James Kyle

- Status changed from New to Resolved

Thanks, Jean-Philippe!

Manually copying over did the trick. | rolled back after that and found a merge gone wrong that led to the section not updating. So, file this away as a
pebkac.

#7 - 2011-12-22 03:16 - Mischa The Evil
- Status changed from Resolved to Closed

- Resolution set to Invalid

#8 - 2012-03-22 08:59 - shravan kumar
- Status changed from Closed to Reopened

- Assignee set to Jean-Philippe Lang
https://www.redmine.org/projects/redmine/repository/svn/revisions/7926/entry/trunk/public/javascripts/application.js#L337
https://www.redmine.org/projects/redmine/repository/svn/revisions/7926/entry/trunk/public/javascripts/application.js#L384

Still i have same problem.
| tried to replace application.js file form the above 7926#L337

Still promotes for authentication.

#9 - 2012-08-03 14:35 - Moritz Kobel

Replacing the application.js is not enough. You have to add the csrf-token to the html header in the template:

http://www.kobelnet.ch/Blog/2012/08/03/fix_redmine_csrf _post_request_issue

#10 - 2013-05-28 16:09 - Toshi MARUYAMA

- Affected version (unused) deleted (devel)

#11 - 2013-05-28 16:10 - Toshi MARUYAMA

- Status changed from Reopened to Closed

This issue is on Rails2 and obsolete.
